/**
 * 演示程序当前的 “注册/登录” 等操作，是基于 “本地存储” 完成的
 * 当您要参考这个演示程序进行相关 app 的开发时，
 * 请注意将相关方法调整成 “基于服务端Service” 的实现。
 **/
(function($, owner) {
	var w = null;
	/**
	 * 用户登录
	 **/
	owner.login = function(loginInfo, callback) {
		callback = callback || $.noop;
		loginInfo = loginInfo || {};
		loginInfo.account = loginInfo.account || '';
		loginInfo.password = loginInfo.password || '';
		if(!loginInfo.nikeName) {
			if(!chekLoginNames1(loginInfo.account, callback)) {
				return;
			}
			if(loginInfo.password.length < 6) {
				return callback('密码最短为 6 个字符');
			}
		}

		var url = "" + setting.postUrl + "Account/Login";
		loginInfo.AppKey = setting.appKey;

		//弹出正在登录提示框 
		w = plus.nativeUI.showWaiting("正在处理，请等待...", {
			modal: true
		});
		ajaxRequest(url, "post", loginInfo, function(data) {
			var State = data.State;
			if(State == 1) {
				loginInfo.id = data.Obj.Id;
				loginInfo.Mobile = data.Obj.Mobile;
				loginInfo.password = data.Obj.Password;
				loginInfo.weixinId = data.Obj.weixinId;
				loginInfo.QQid = data.Obj.QQid;
				loginInfo.sinaId = data.Obj.sinaId;
				loginInfo.qqName = data.Obj.qqName;
				loginInfo.weixinName = data.Obj.weixinName;
				loginInfo.sinaName = data.Obj.sinaName;

				tongbuget({
					AccountId: loginInfo.id,
					onSucceed: function() {
						localStorage.setItem('$users', JSON.stringify(loginInfo));
						w.close();
						return callback();
					},
					onError: function(err) {
						w.close();
						plus.nativeUI.toast(err);
					}
				});
			}
		}, false, function(xx, errcode, errmessage) {
			w.close();
			return callback(errmessage);
		});
	};
	owner.logout = function(callback) {
		var w = plus.nativeUI.showWaiting("正在同步云数据，请等待...", {
			modal: true
		});
		tongbu({
			onSucceed: function() {
				//退出
				db.transaction(function(tx) {
					tx.executeSql('delete from DictionariesConsumption'); //个人表删除
					tx.executeSql('delete from books'); //列表
					//tx.executeSql('insert into DictionariesConsumption select * from SYSDictionariesConsumption');
				}, function() {
					//失败
					w.close();
					return callback('失败');
				}, function() {
					localStorage.removeItem('$users');
					localStorage.removeItem("lock");
					localStorage.removeItem('yuntongbu');
					w.close();
					return callback();
				});

			},
			onError: function(err) {
				w.close();
				return callback(err);
			}
		});

	}
	owner.createState = function(name, callback) {
		var state = owner.getState();
		state.account = name;
		state.token = "token123456789";
		owner.setState(state);
		return callback();
	};

	/**
	 * 新用户注册
	 **/
	owner.reg = function(regInfo, callback) {
		callback = callback || $.noop;
		regInfo = regInfo || {};
		regInfo.account = regInfo.account || '';
		regInfo.password = regInfo.password || '';
		if(!regInfo.nikeName) {
			if(!chekLoginName(regInfo.account, callback)) {
				return;
			}
			if(regInfo.password.length < 6) {
				return callback('密码最短需要 6 个字符');
			}
		}

		var url = "" + setting.postUrl + "Account/Reg";

		//		datas=JSON.stringify(datas);
		ajaxRequest(url, "post", regInfo, function(data) {
			var State = data.State;
			if(State == 1) {
				//				localStorage.removeItem('$users');
				//				var users = JSON.parse(localStorage.getItem('$users') || '[]');
				//				users.push(regInfo);
				//				localStorage.setItem('$users', JSON.stringify(users));
				return callback();
			}
		}, false, function(xx, errcode, errmessage) {
			return callback(errmessage);
		});
	};
	/**
	/**
	 * 获取手机验证码
	 **/
	owner.getMoblieCode = function(Mobile, opc, callback) {
		var url = setting.postUrl + 'Account/InsterCode';
		if(!chekLoginName(Mobile, callback)) {
			return;
		}
		var datas = {
			Mobile: Mobile,
			opc: opc
		}
		var w = plus.nativeUI.showWaiting("正在发验证码，请等待...", {
			modal: true
		});
		tongji('yanzhenmafasong');
		ajaxRequest(url, 'post', datas, function(data) {
			var dataList = data.Obj;
			w.close();
			jQuery('#code').focus(); 
			countdownTime();
		}, false, function(xx, errcode, errmessage) {
			w.close();
			return callback(errmessage);
		});
	}

	/**
		/**
		 * 获取当前状态
		 **/
	owner.getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		return JSON.parse(stateText);
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {};
		localStorage.setItem('$state', JSON.stringify(state));
		//var settings = owner.getSettings();
		//settings.gestures = '';
		//owner.setSettings(settings);
	};

	/**
	 * 找回密码
	 **/
	owner.forgetPassword = function(email, callback) {
		callback = callback || $.noop;
		if(!checkEmail(email)) {
			return callback('邮箱地址不合法');
		}
		return callback(null, '新的随机密码已经发送到您的邮箱，请查收邮件。');
	};

	/**
	 * 获取应用本地配置
	 **/
	owner.setSettings = function(settings) {
		settings = settings || {};
		localStorage.setItem('$settings', JSON.stringify(settings));
	}

	/**
	 * 设置应用本地配置
	 **/
	owner.getSettings = function() {
		var settingsText = localStorage.getItem('$settings') || "{}";
		return JSON.parse(settingsText);
	}
}(mui, window.app = {}));

var commData = {
	//发送短信间隔时间
	smstime: 120
};
//发送短信验证码倒计时
var countdownTime = function() {
	var usmscodebtn = $('#usmscodebtn');
	if(commData.smstime <= 0) {
		usmscodebtn.attr('disabled', false);
		//commEle.usmscodebtn.attr('disabled', false);
		usmscodebtn.html('发送验证码');
		commData.smstime = 121;
	} else {
		usmscodebtn.attr('disabled', true);
		usmscodebtn.html((commData.smstime > 9 ? commData.smstime : "0" + commData.smstime) + '秒');
		setTimeout("countdownTime()", 1000);
	}
	commData.smstime--;
}

//检查登录手机号
function chekLoginName(mobile, callback) {
	if(mobile == "" || mobile == null) {

		return callback('请输入手机号');
	}
	if(!checkMobile(mobile)) {
		return callback('手机号码不正确');
	}
	return true;
}
//检查登录手机号
function chekLoginNames1(mobile, callback) {
	if(mobile == "" || mobile == null) {

		return callback('请输入手机号或者邮箱');
	}
	if(!checkMobile(mobile) && !checkEmail(mobile)) {
		return callback('手机号码或者邮箱不正确');
	}
	return true;
}

var checkMobile = function(Mobile) {
	Mobile = Mobile || '';
	var reg = "^((13[0-9])|(15[^4,\\D])|(17[0-9])|(18[0-9])|(147))\\d{8}$";
	return new RegExp(reg).test(Mobile);
};
var checkEmail = function(email) {
	email = email || '';
	return(email.length > 3 && email.indexOf('@') > -1);
};